#include <P33FXXXX.h>
#include "i2c.h"

void	I2C1_Initial(void)
{
		I2C1BRG = 50 ;							//	100K @ I2C1BRG = 39 when Fcy = 8M
		I2C1CON = 0b1001001000000000 ;
}

void	StartI2C1(void)
{
		I2C1CONbits.SEN = 1 ;
		while ( I2C1CONbits.SEN ) ;
		IFS1bits.MI2C1IF = 0 ;
}

void	RestartI2C1(void)
{
		I2C1CONbits.RSEN = 1 ;
		while ( I2C1CONbits.RSEN ) ;
		IFS1bits.MI2C1IF = 0 ;
}

void	StopI2C1(void)
{
		I2C1CONbits.PEN = 1 ;
		while ( I2C1CONbits.PEN ) ;
		IFS1bits.MI2C1IF = 0 ;

}

void	WriteMI2C1(unsigned char M_Data)
{
		I2C1TRN = M_Data ;
		while ( IFS1bits.MI2C1IF == 0 )	;
		IFS1bits.MI2C1IF = 0 ;

}

unsigned char	ReadMI2C1(void)
{
		unsigned char My_Read ;

			I2C1CONbits.RCEN = 1 ;		
			
			while ( IFS1bits.MI2C1IF == 0 ) ;
			My_Read = (unsigned char)I2C1RCV ;
			IFS1bits.MI2C1IF = 0 ;
			I2C1CONbits.RCEN = 0 ;	

		return My_Read ;
}

void NackMI2C1(void) 
{
		I2C1CONbits.ACKDT = 1 ;
		I2C1CONbits.ACKEN = 1 ;
		while ( IFS1bits.MI2C1IF == 0 ) ;
		IFS1bits.MI2C1IF = 0 ; 

}

unsigned char	ReadI2C1wAddr(unsigned char I2C_Addr)
{
	unsigned char Read_Result ;

		StartI2C1() ;
		WriteMI2C1(I2C_Addr) ;
		RestartI2C1() ;
		WriteMI2C1(I2C_Addr+1) ;

		Read_Result = ReadMI2C1() ;
		NackMI2C1() ;
		StopI2C1() ;

	return Read_Result ;	
}

