#include <P33FXXXX.h>
#include "uart.h"

//Macros for Configuration Fuse Registers (copied from device header file):
//_FOSC(CSW_FSCM_OFF & XT_PLL8);  //Set up for crystal multiplied by 8x PLL
//_FWDT(WDT_OFF);                 //Turn off the Watch-Dog Timer.
//_FBORPOR(MCLR_EN & PWRT_OFF);   //Enable MCLR reset pin and turn off the power-up timers.
//_FGS(CODE_PROT_OFF);            //Disable Code Protection

#define SW5 	PORTEbits.RE8
#define SW6	PORTEbits.RE9
#define	LED	PORTDbits.RD4

#define		E_LED1		LATEbits.LATE6
#define		E_LED2		LATEbits.LATE7
#define		DIR_E_LED1	TRISEbits.TRISE6
#define		DIR_E_LED2	TRISEbits.TRISE7

#define		INPUT 		1
#define		OUTPUT	0

#define		Ctrl_U1RX 	TRISFbits.TRISF2 
#define		Ctrl_U1TX 	TRISFbits.TRISF3 
#define		Ctrl_U2RX 	TRISFbits.TRISF4
#define		Ctrl_U2TX 	TRISFbits.TRISF5 

int		LATD4_ON ;

unsigned TotalLoop = 0 ;
unsigned char	*Menu[3]={"Microchip","Calvin","PIC"} ;
unsigned char	Str_Char ;

void 	Delay_Long(void)
{
	int	Loop1 , Loop2 ;
	
	for ( Loop1 = 0 ; Loop1 < 10 ; Loop1 ++ ) 
	for ( Loop2 = 0 ; Loop2 < 10000 ; Loop2 ++ ) ;

}

void	Str_Test(unsigned char **Ptr)
{
	Str_Char = Ptr[0][0];	
}

int main ( void )
{
	 //	The settings below set up the oscillator and PLL for 16 MIPS as
        //	follows:
        //            	Crystal Frequency  * (DIVISOR+2)
        //	 Fcy =    ------------------------------------------------
        //              	PLLPOST * (PRESCLR+2) * 2

		Str_Test(&Menu[0]) ;	

        	PLLFBD = 0x009E;				//	0x9E = 158
        	CLKDIV = 0x0048;				// 	PLLPOST = 01 > Output / 4   & PLLPRE = 8 > Presclaer of PLL = 8+2 = 10

		SRbits.IPL = 7 ;

	//		PLLFBDbits.PLLDIV = 6 ;
	//		CLKDIVbits.PLLPRE = 0 ;
	//		CLKDIVbits.PLLPOST = 1 ;

		DIR_E_LED1 = OUTPUT ;
		DIR_E_LED2 = OUTPUT ;

		E_LED1 = 0 ;
		E_LED2 = 1 ;

	while (1) 
	{
		Delay_Long( ) ;
		Delay_Long( ) ;
		Delay_Long( ) ;
		Delay_Long( ) ;
		Delay_Long( ) ;

		E_LED1 = ! E_LED1 ;
		E_LED2 = ! E_LED2 ;

	}



}
