#include <P30FXXXX.h>
#include "i2c.h"

void	I2C1_Initial(void)
{
		I2CBRG = 50 ;							//	100K @ I2C1BRG = 39 when Fcy = 8M
		I2CCON = 0b1001001000000000 ;
}

void	StartI2C1(void)
{
		I2CCONbits.SEN = 1 ;
		while ( I2CCONbits.SEN ) ;
		IFS0bits.MI2CIF = 0 ;
}

void	RestartI2C1(void)
{
		I2CCONbits.RSEN = 1 ;
		while ( I2CCONbits.RSEN ) ;
		IFS0bits.MI2CIF = 0 ;
}

void	StopI2C1(void)
{
		I2CCONbits.PEN = 1 ;
		while ( I2CCONbits.PEN ) ;
		IFS0bits.MI2CIF = 0 ;

}

void	WriteMI2C1(unsigned char M_Data)
{
		I2CTRN = M_Data ;
		while ( IFS0bits.MI2CIF == 0 )	;
		IFS0bits.MI2CIF = 0 ;

}

unsigned char	ReadMI2C1(void)
{
		unsigned char My_Read ;

			I2CCONbits.RCEN = 1 ;		
			
			while ( IFS0bits.MI2CIF == 0 ) ;
			My_Read = (unsigned char)I2CRCV ;
			IFS0bits.MI2CIF = 0 ;
			I2CCONbits.RCEN = 0 ;	

		return My_Read ;
}

void NackMI2C1(void) 
{
		I2CCONbits.ACKDT = 1 ;
		I2CCONbits.ACKEN = 1 ;
		while ( IFS0bits.MI2CIF == 0 ) ;
		IFS0bits.MI2CIF = 0 ; 

}

unsigned char	ReadI2C1wAddr(unsigned char I2C_Addr)
{
	unsigned char Read_Result ;

		StartI2C1() ;
		WriteMI2C1(I2C_Addr) ;
		RestartI2C1() ;
		WriteMI2C1(I2C_Addr+1) ;

		Read_Result = ReadMI2C1() ;
		NackMI2C1() ;
		StopI2C1() ;

	return Read_Result ;	
}

