/*****************************************************************************
 *
 * Main entry into the application.
 *
 *****************************************************************************
 * FileName:        main.c
 * Dependencies:    
 * Processor:       
 * Compiler:       	
 * Linker:          
 * Company:         Microchip Technology Incorporated
 *
 * Software License Agreement
 *
 * The software supplied herewith by Microchip Technology Incorporated
 * (the "Company") is intended and supplied to you, the Company's
 * customer, for use solely and exclusively with products manufactured
 * by the Company. 
 *
 * The software is owned by the Company and/or its supplier, and is 
 * protected under applicable copyright laws. All rights are reserved. 
 * Any use in violation of the foregoing restrictions may subject the 
 * user to criminal sanctions under applicable laws, as well as to 
 * civil liability for the breach of the terms and conditions of this 
 * license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES, 
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED 
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT, 
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR 
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 *
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Ross Fosler			06/07/05	...	
 * 
 *****************************************************************************/

#include	<p24FJ128GA010.h>
#include	"lcd.h"


//********************************************************************************

//***********************************************************
// STEP 5:
// Change text to your name
//***********************************************************/
const unsigned char my_name[] = "Text Test";
const unsigned char * pname;


// Extra Credit Variables
const unsigned char my_banner[][24] = {"Banner 1", "Banner 2", "Banner 3"};		// Banners to display
const unsigned char * pban;														// Pointer to char of current banner
unsigned int num_banners;														// Number of banners to display
unsigned int i;																	// Banner counter
unsigned int wait_time = 0;

unsigned char TTT ;		
unsigned int	Buffer_PMDIN1 ;	
int				TestLoop ;											// Time delay counter
//********************************************************************************

void LCDPutChar( unsigned char TheChar)
{
		

			PMADDR = 0x0001;
			PMDIN1 = (unsigned int)TheChar;
}

int main(void)
{

//		AD1PCFG = 0xffff ;
//		AD2PCFG = 0xffff ;

	//	Initial PMP module 

		//********************************************************************************
			//********************************************************************************
			//  STEP 1:
			//	Configure PMPCON: PMP on, address/data not multiplexed, PMPBE active high, 
			//	PMPWR I/O, PMPRD I/O, 8-bit data, PMPENB and PMPRD/~PMPWR active high.
			//********************************************************************************/
			PMCON = 0b1000001100000111;


			//********************************************************************************
			//	STEP 2:
			//	Configure PMPMODE: Interrupts, stall, buffers, inc/dec off, 8 bit mode,
			//	combined read/write with byte enable signals, and max the 3 wait delays.
			//********************************************************************************/
			PMMODE = 0x3FF;

			//********************************************************************************
			//	STEP 3:	
			//	Configure PMPEN: Enable A0 function to control RS and disable all other 
			//	PMP address pins.
			//********************************************************************************/
			PMPEN = 0x0001;

			//********************************************************************************
			// 	STEP 4:
			//	Configure PMPADDR: A0 selects type of instruction, either command or data.
			//	This is a command so A0 should be low.
			//********************************************************************************/
			PMADDR = 0x0000;
		
		//********************************************************************************

while(1)
{

		for ( TestLoop = 0 ; TestLoop<5 ; TestLoop++) ;

			PMADDR = 0x0000 ;
			Buffer_PMDIN1 = PMDIN1 ;
			//	PMDIN1 = 0x88 ;

		for ( TestLoop = 0 ; TestLoop<5 ; TestLoop++) ;

			PMADDR = 0x0001 ;
			PMDIN1 = 0x99 ;
			// Buffer_PMDIN1 = PMDIN1 ;



}
//***********************************************************
// Extra credit:
// Uncomment this code and modify it to display the rotating banners in my_banner.
// Useful variables and functions: pban, ban_len, num_banners, wait_time, mLCDPutChar(char), mLCDClear()
// ************THIS MAY BE TOO LONG FOR A LAB ************
//***********************************************************/
//		// Display rotating banners
//		if (!mLCDIsBusy()){
//			if(*pban) {						//Print current banner
//				mLCDPutChar(*pban);
//				pban++;
//			}else if(!wait_time){			//Increment to next banner after some time
//				mLCDClear();
//				if(i >= num_banners) i=0;
//				pban = my_banner[i++];
//			}
//			
//			wait_time++;
//		}
//***********************************************************/
		
	
}
