/*****************************************************************************
 *
 * Main entry into the application.
 *
 *****************************************************************************
 * FileName:        main.c
 * Dependencies:    
 * Processor:       
 * Compiler:       	
 * Linker:          
 * Company:         Microchip Technology Incorporated
 *
 * Software License Agreement
 *
 * The software supplied herewith by Microchip Technology Incorporated
 * (the "Company") is intended and supplied to you, the Company's
 * customer, for use solely and exclusively with products manufactured
 * by the Company. 
 *
 * The software is owned by the Company and/or its supplier, and is 
 * protected under applicable copyright laws. All rights are reserved. 
 * Any use in violation of the foregoing restrictions may subject the 
 * user to criminal sanctions under applicable laws, as well as to 
 * civil liability for the breach of the terms and conditions of this 
 * license.
 *
 * THIS SOFTWARE IS PROVIDED IN AN "AS IS" CONDITION. NO WARRANTIES, 
 * WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT NOT LIMITED 
 * TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. THE COMPANY SHALL NOT, 
 * IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL OR 
 * CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
 *
 *
 * Author               Date        Comment
 *~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * Calvin Ho			06/07/05	...	
 * 
 *****************************************************************************/

#include	<p24FXXXX.h>
#include	"lcd.h"

void	PMP_Initial(void) ;

const unsigned char MyName[] = "Microchip";
const unsigned char * pname;



int main(void)
{

	LCD_Delay200us() ;
	LCD_Delay200us() ;

		PMP_Initial() ;

		AD1PCFGbits.PCFG15 = 1 ;		// RB15(AN15) shared with PMPA0

		LCD_Initial() ;

		pname = MyName ;

		LCD_SetCursor(3,1) ;
		
		while( *pname != 0x00 )
		{
				if ( !LCDIsBusy())
				LCD_PutChar(*pname++ ) ;
		}

	while(1) ;

	Nop() ;
}


void	PMP_Initial(void)
{
			//********************************************************************************
			//  STEP 1:
			//	Configure PMPCON: PMP on, address/data not multiplexed, PMPBE active high, 
			//	PMPWR I/O, PMPRD I/O, 8-bit data, PMPENB and PMPRD/~PMPWR active high.
			//********************************************************************************/
			PMCON = 0b1000001100000111;


			//********************************************************************************
			//	STEP 2:
			//	Configure PMPMODE: Interrupts, stall, buffers, inc/dec off, 8 bit mode,
			//	combined read/write with byte enable signals, and max the 3 wait delays.
			//********************************************************************************/
			PMMODE = 0x3FF;

			//********************************************************************************
			//	STEP 3:	
			//	Configure PMPEN: Enable A0 function to control RS and disable all other 
			//	PMP address pins.
			//********************************************************************************/
			PMPEN = 0x0001;

			//********************************************************************************
			// 	STEP 4:
			//	Configure PMPADDR: A0 selects type of instruction, either command or data.
			//	This is a command so A0 should be low.
			//********************************************************************************/
			PMADDR = 0x0000;
}
