

#include <p18f8722.h>	// p18cxxx.h must have current processor
#include "APP023_GLCD.h"
#include <stdlib.h>
#include <usart.h>
#include <string.h>
#include <delays.h>
#include <stdio.h>
#include	 <usart.h>

#define	SW1						PORTBbits.RB0
#define	SW2						PORTAbits.RA4
#define	TRIS_SW1					TRISBbits.TRISB0 
#define	TRIS_SW2					TRISAbits.TRISA4	
#define	LED_PORT 					LATE
#define	TRIS_LED_PORT			TRISE 
#define	ADC_FULL					255

#define	INPUT		1 
#define	OUTPUT	0
	
void Delay_100(void) ;
void	Print_Welcome(void) ;
void	Initial_Peripherals( void ) ;
void	I2C_Initialize( void) ;
void	BZ_ON(int ) ;

char 		TempASCII[10] ;

char		OutBuffer1[64] ;
char		SW1_LOCKED = 0 ;
char		Process_IO = 0 ;
char		Timer_Process_IO = 0 ;
char		SW1_Counter ; 
char		Y_PositionNow ;

unsigned char		Value_AN0 , Value_AN1 ;
unsigned char		Loop_Process_IO ;

unsigned	PrintLoop ;

int			SendLoop = 0  ;
int			 BZ_Timer = 0 ;

unsigned 	char 	My_Temp ;	

const rom unsigned char StrTemp[] = "ū:  " ;
const rom unsigned char StrADC[] = "AD1=    AD2=" ;
const rom unsigned char Welcome3[] = "ڬO  APP023" ;
const rom unsigned char *Message[3] = {"PIC18F8XXX" , "PIC18F87JXX" , "PIC18F8680" } ;

int	PrintCounter = 0 , NullCounter = 0  , PacketNumber = 0 ;

union
	{
		unsigned char	Bytes[2] ;
		unsigned int		Word ;	
	}     Word2Byte  ;

	unsigned char 	Var1,Var2 ;

	unsigned long	TX_ID1 ;
	unsigned char	TX_Data_Buf1[8] ;

	unsigned long	RX_ID1 ;
	unsigned char	RX_Data_Buf1[8] ;
	unsigned char	RX_Data_Len1	;

	unsigned long	RX_ID2 ;
	unsigned char	RX_Data_Buf2[8] ;
	unsigned char	RX_Data_Len2	;		


void InitializeUSART(void)
{
    	TRISCbits.TRISC7=1 ; // RX
    	TRISCbits.TRISC6=1 ; // TX

    	SPBRG = 0x08 ;
    	SPBRGH = 0x02;      	// 0x208 for 19200 bps @ 40Mhz Fosc
							// Formula : BaudRate = Fosc/4(BRG+1)  if BRG16 = 1 and BRGH = 1 ;
							// Thus ..      BRG = (Fosc/(4*BaudRate)) - 1 

    	TXSTA = 0x24;       		// TX enable BRGH=1
    	RCSTA = 0x90;       		// continuous RX
    	BAUDCON = 0x08;     	// BRG16 = 1

}//end InitializeUSART

void main( void )
{
	int 	Loop1 , Loop2 ;

	OSCCONbits.IRCF0 = 1 ;
	OSCCONbits.IRCF1 = 1 ;
	OSCCONbits.IRCF2 = 1 ;

	TRISGbits.TRISG0 = 1 ;				// CANTX
	TRISGbits.TRISG2 = 1 ;				// CANRX

	TRIS_SW1	= INPUT ;
	TRIS_SW2 = INPUT ;
	TRIS_LED_PORT = OUTPUT ;

	TRISJ = 0 ;
	PORTJ = 0 ;
	TRISD = 0 ;
	PORTD = 0xff ;

	LED_PORT = 0x00 ;

	Loop_Process_IO = 0 ;
	
	//	***************************************************************									
	//	AD Modul initialize for PIC18F8722
	//	***************************************************************
	ADCON1 = 	0b00001100 ;			//  	AN0 .. AN2 are analog 
	ADCON2 = 	0b00100111;			//  	Left Justified  , 8 TAD for Acquisition , internal RC as TAD!!
	ADCON0 = 	0b00000001 ;			// 	Initial ADCON0 for A/D Module 
	CMCON = 	0b00000111 ;			// 	Disable Comparator module !!
										//	Channel Location = bit <5..2> of ADCON0

		LCD_Delay_nms( 200 ) ;
		GLCD_Initial( ) ;
		InitializeUSART( ) ;
		Initial_Peripherals( ) ;
		Print_Welcome( ) ;

	SW1_Counter = 0 ;

	LATE =  ( (char) PrintLoop ) ^ 0xff ;

	I2C_Initialize( ) ;

		Nop( ) ;

	while (1)
	{
	    if ( Process_IO )
	{

		Process_IO = 0 ;

		LED_PORT = ~ Loop_Process_IO ;
		Loop_Process_IO ++ ;

		//	Convert Channel - 0 
		ADCON0 &= 0b11000011 ;

		ADCON0bits.GO = 1 ;
		while ( ADCON0bits.GO) ;
			My_Temp = ADRESH ;
			Value_AN0 = ADRESH ;
				itoa(My_Temp , TempASCII) ;
				setcurGLCD(1,2) ;
				putrsGLCD( "    ") ;
					setcurGLCD(1,2) ;
					putsGLCD( TempASCII) ;

		//	Convert Channel - 1 

		ADCON0 &= 0b11000011 ;
		ADCON0 |=    0b00000100 ;

		ADCON0bits.GO = 1 ;
		while ( ADCON0bits.GO) ;
			My_Temp = ADRESH ;
			Value_AN1 = ADRESH ;
				itoa(My_Temp , TempASCII) ;
				setcurGLCD(1,6) ;
				putrsGLCD( "    ") ;
					setcurGLCD(1,6) ;
					putsGLCD( TempASCII) ;

		//	Convert Channel -2	-> SW3 .. SW6 

		ADCON0 &= 0b11000011 ;
		ADCON0 |=    0b00001000 ;

		ADCON0bits.GO = 1 ;
		while ( ADCON0bits.GO) ;
			My_Temp = ADRESH ;

			if ( My_Temp <= 5 )
				{
					BZ_ON(30) ;
					setcurGLCD(0,6) ;
					putrsGLCD( "SW3") ;			
				}
			else if ( My_Temp >= ((ADC_FULL/3) - 5) && My_Temp <= (( ADC_FULL/3) +5)) 
				{
					BZ_ON(30) ;
					setcurGLCD(0,6) ;
					putrsGLCD( "SW4") ;
				}
			else if ( My_Temp >= ((ADC_FULL/2) - 5) && My_Temp <= (( ADC_FULL/2) +5)) 
				{
					BZ_ON(30) ;
					setcurGLCD(0,6) ;
					putrsGLCD( "SW5") ;
				}
			else if ( My_Temp >= ((ADC_FULL*2/3) - 5) && My_Temp <= (( ADC_FULL*2/3) +5)) 
				{
					BZ_ON(30) ;
					setcurGLCD(0,6) ;
					putrsGLCD( "SW6") ;
				}

		//	Checking SW1 & SW2
			if ( ! SW1 )
				{
					BZ_ON(30) ;
					setcurGLCD(0,6) ;
					putrsGLCD( "SW1") ;
				}
			else if ( ! SW2 )
				{
					BZ_ON(30) ;
					setcurGLCD(0,6) ;
					putrsGLCD( "SW2") ;
				}
			else if ( My_Temp >= ADC_FULL -5 ) 
				{
					setcurGLCD(0,6) ;
					putrsGLCD( "SWx") ;
				}
		
		My_Temp = 0x00 ;
		My_Temp = MCP9800_ByteRead( 0x00 ) ; 
			itoa(My_Temp , TempASCII) ;
							setcurGLCD(0,3) ;
							putrsGLCD( "  C") ;;
					setcurGLCD(0,3) ;
					putsGLCD(TempASCII) ;

			putrs1USART("ADC Value : AN0 =  " ) ;
			itoa((unsigned int)Value_AN0,TempASCII) ; 
			puts1USART(TempASCII) ;
			putrs1USART("\x0d\x0a") ;
			

			Nop( ) ;
	}	//	End of if (Process_IO) 
	}	//	End of While(1) ;
	
}		//	End of Main ;

void	Initial_Peripherals( void ) 
{
		T2CON = 0b00000111 ;			//	Timer 2 = ON , Prescaler = 1:16
		ECCP1CON = 0b00001100 ;

		TRISCbits.TRISC2 = 1 ;
		PR2 = 150 ;
		CCPR1H = 75 ;
		CCPR1L = 75 ;

										//	Timer 1 
		TMR1H = (int) ( 65536-10000 ) / 256 ;
		TMR1L = (int) ( 65536-10000 ) % 256 ;
		T1CON = 0b10110001 ;
		PIR1bits.TMR1IF = 0 ;
		PIE1bits.TMR1IE = 1 ;
		RCONbits.IPEN = 1 ;
		INTCONbits.GIEH = 1 ;
		INTCONbits.GIEL = 0 ;

}

void	Print_Welcome(void)
{
				setcurGLCD(0,0) ;
				putrsGLCD( StrTemp ) ;
				setcurGLCD(1,0) ;				// Set Cursor @ ( Y,X )
				putrsGLCD( StrADC ) ;
				setcurGLCD(2,0) ;
				putrsGLCD(Welcome3) ;
				setcurGLCD(3,0) ;
				putrsGLCD("ϥ PIC18F8722") ;
			
				Delay_100( ) ;
}


void	hexbtoa(unsigned char BinaryValue , unsigned char *ResultBuffer) 
{

		unsigned char TempChar1 ;
		
		TempChar1 = ( BinaryValue >> 4 ) & 0x0f ;
		if ( TempChar1 > 9 )		*ResultBuffer++ = TempChar1 + 'A'-10 ;
		else						*ResultBuffer++ = TempChar1 + '0' ;

		TempChar1 = ( BinaryValue & 0x0f ) ;
		if ( TempChar1 > 9 )		*ResultBuffer++ = TempChar1 + 'A'-10 ;
		else						*ResultBuffer++ = TempChar1 + '0' ;
		
		*ResultBuffer = 0x00 ;
}


void Delay_100(void)
{
	int  X1 ;

	for (X1 = 0 ; X1 < 10000 ; X1 ++ ) ;

}


//************************************************
//*       #pragma Interrupt Declarations         *
//************************************************
#pragma interrupt isr_high 		//	save = PRODL,PRODH,FSR0L,FSR0H
#pragma interruptlow isr_low 		//	save = WREG,STATUS,BSR,PRODL,PRODH,FSR0L,FSR0H

//************************************************
//* Function: isr_high_direct                    *
//*   - Direct execution to the actual           *
//*     high-priority interrupt code.            *
//************************************************
#pragma code isrhighcode = 0x0000008

void isr_high_direct(void)	
{  
   //***EXERCISE 2 CODE HERE***
                         										
     _asm 		//begin in-line assembly
     goto isr_high	//go to isr_high function
     _endasm 		//end in-line assembly
}

#pragma code


//************************************************
//* Function: isr_low_direct                     *
//*   - Direct execution to the actual           *
//*     low-priority interrupt code.             *
//************************************************
#pragma code isrlowcode = 0x0000018

void isr_low_direct(void)
{  
   //***EXERCISE 2 CODE HERE***
                        										
     _asm 		//begin in-line assembly
     goto isr_low	//go to isr_high function
     _endasm		//end in-line assembly
}
#pragma code


//************************************************
//* Function: isr_high(void)                     *     
//*   High priority interrupt will               *
//************************************************
void isr_high(void)
{

		// 	Check if Timer1 interrupt occured !!
		if ( PIR1bits.TMR1IF )
		{
			PIR1bits.TMR1IF = 0 ;
				TMR1H = ((int) 65535-10000 ) / 256 ;
				TMR1L = ((int) 65535-10000 ) % 256 ;

				if ( BZ_Timer >0 )
					{
						BZ_Timer -- ;
						if ( BZ_Timer == 0 )		TRISCbits.TRISC2 = 1 ;
					}

			Timer_Process_IO ++ ;
			if ( Timer_Process_IO >= 15 )
			{
				Timer_Process_IO = 0 ;
				Process_IO = 1 ;
			}
		}
 
}


void	BZ_ON(int	BZ_ON_Time )
{
		TRISCbits.TRISC2 = 0 ;
		BZ_Timer = BZ_ON_Time ;

}									


//************************************************
//* Function: isr_low(void)                      *
//*   Low priority interrupt will                *
//*   - Check cause of interrupt and             *
//************************************************
void isr_low(void)
{
 
}				


