

#include <p18f87J10.h>	// p18cxxx.h must have current processor
#include "APP023_GLCD.h"
#include <stdlib.h>
#include <usart.h>
#include <string.h>
#include <delays.h>
#include	<stdio.h>

#define	SW1						PORTBbits.RB0
#define	SW2						PORTAbits.RA4
#define	TRIS_SW1					TRISBbits.TRISB0 
#define	TRIS_SW2					TRISAbits.TRISA4	
#define	LED_PORT 					LATE
#define	TRIS_LED_PORT			TRISE 

#define	INPUT		1 
#define	OUTPUT	0
	
void 		Delay_100(void) ;

char 		TempASCII[10] ;

char		OutBuffer1[64] ;
char		SW1_LOCKED = 0 ;
char		SW1_Counter ; 
char		Y_PositionNow ;
unsigned	PrintLoop ;

int			SendLoop = 0  ;

const rom unsigned char Welcome1[] = "    wѥ[  " ;
const rom unsigned char Welcome2[] = " 16-bit Seminar" ;
const rom unsigned char Welcome3[] = "ڬO  APP023" ;
const rom unsigned char *Message[3] = {"PIC18F8XXX" , "PIC18F87JXX" , "PIC18F8680" } ;

int	PrintCounter = 0 , NullCounter = 0  , PacketNumber = 0 ;

union
	{
		unsigned char	Bytes[2] ;
		unsigned int		Word ;	
	}     Word2Byte  ;

	unsigned char 	Var1,Var2 ;

	unsigned long	TX_ID1 ;
	unsigned char	TX_Data_Buf1[8] ;

	unsigned long	RX_ID1 ;
	unsigned char	RX_Data_Buf1[8] ;
	unsigned char	RX_Data_Len1	;

	unsigned long	RX_ID2 ;
	unsigned char	RX_Data_Buf2[8] ;
	unsigned char	RX_Data_Len2	;		


void InitializeUSART(void)
{
    	TRISCbits.TRISC7=1 ; // RX
    	TRISCbits.TRISC6=1 ; // TX

    	SPBRG = 0x08 ;
//    	SPBRGH = 0x02;      	// 0x208 for 19200 bps @ 40Mhz Fosc
							// Formula : BaudRate = Fosc/4(BRG+1)  if BRG16 = 1 and BRGH = 1 ;
							// Thus ..      BRG = (Fosc/(4*BaudRate)) - 1 

    	TXSTA = 0x24;       		// TX enable BRGH=1
    	RCSTA = 0x90;       		// continuous RX
//    	BAUDCON = 0x08;     	// BRG16 = 1

}//end InitializeUSART

void main( void )
{
	int 	Loop1 , Loop2 ;


	TRISGbits.TRISG0 = 1 ;				// CANTX
	TRISGbits.TRISG2 = 1 ;				// CANRX

	TRIS_SW1	= INPUT ;
	TRIS_SW2 = INPUT ;
	TRIS_LED_PORT = OUTPUT ;

	TRISJ = 0 ;
	PORTJ = 0 ;
	TRISD = 0 ;
	PORTD = 0xff ;
	
	//	***************************************************************									
	//	AD Modul initialize for PIC18F458X
	//	***************************************************************
	ADCON1 = 	0b00001111 ;
	ADCON2 = 	0b10100010 ;			//  	Right Justified !!
	ADCON0 = 	0b00000001 ;			// 	Initial ADCON0 for A/D Module 
	CMCON = 0b00000111 ;				// 	Disable Comparator module !!

		LCD_Delay_nms( 200 ) ;

		GLCD_Initial( ) ;

		 InitializeUSART( ) ;

				setcurGLCD(0,0) ;
				putrsGLCD( Welcome1 ) ;
	
				setcurGLCD(1,0) ;				// Set Cursor @ ( Y,X )

				putrsGLCD( Welcome2 ) ;

				ClrWdt() ;

				setcurGLCD(2,0) ;
				putrsGLCD(Welcome3) ;
				setcurGLCD(3,0) ;
				putrsGLCD("ϥ PIC18F87J10") ;
			
				ClrWdt() ;
			
				Delay_100( ) ;
	//
	// Initialize CAN Communication Module !!
	// The Sequence of Parameter is SJW,BRP,PHASEG1,PHASEG2,PROPSEG, Mode !!
	//
	


	SW1_Counter = 0 ;

	LATE =  ( (char) PrintLoop ) ^ 0xff ;

	while (1)
	{

		ClrWdt( ) ;

	}
	
}



void	hexbtoa(unsigned char BinaryValue , unsigned char *ResultBuffer) 
{

		unsigned char TempChar1 ;
		
		TempChar1 = ( BinaryValue >> 4 ) & 0x0f ;
		if ( TempChar1 > 9 )		*ResultBuffer++ = TempChar1 + 'A'-10 ;
		else						*ResultBuffer++ = TempChar1 + '0' ;

		TempChar1 = ( BinaryValue & 0x0f ) ;
		if ( TempChar1 > 9 )		*ResultBuffer++ = TempChar1 + 'A'-10 ;
		else						*ResultBuffer++ = TempChar1 + '0' ;
		
		*ResultBuffer = 0x00 ;
}


void Delay_100(void)
{
	int  X1 ;

	for (X1 = 0 ; X1 < 10000 ; X1 ++ ) ;

}


//************************************************
//*       #pragma Interrupt Declarations         *
//************************************************
#pragma interrupt isr_high 		//	save = PRODL,PRODH,FSR0L,FSR0H
#pragma interruptlow isr_low 		//	save = WREG,STATUS,BSR,PRODL,PRODH,FSR0L,FSR0H

//************************************************
//* Function: isr_high_direct                    *
//*   - Direct execution to the actual           *
//*     high-priority interrupt code.            *
//************************************************
#pragma code isrhighcode = 0x0000008

void isr_high_direct(void)	
{  
   //***EXERCISE 2 CODE HERE***
                         										
     _asm 		//begin in-line assembly
     goto isr_high	//go to isr_high function
     _endasm 		//end in-line assembly
}

#pragma code


//************************************************
//* Function: isr_low_direct                     *
//*   - Direct execution to the actual           *
//*     low-priority interrupt code.             *
//************************************************
#pragma code isrlowcode = 0x0000018

void isr_low_direct(void)
{  
   //***EXERCISE 2 CODE HERE***
                        										
     _asm 		//begin in-line assembly
     goto isr_low	//go to isr_high function
     _endasm		//end in-line assembly
}
#pragma code


//************************************************
//* Function: isr_high(void)                     *     
//*   High priority interrupt will               *
//************************************************
void isr_high(void)
{
 
}									


//************************************************
//* Function: isr_low(void)                      *
//*   Low priority interrupt will                *
//*   - Check cause of interrupt and             *
//************************************************
void isr_low(void)
{
 
}				


